// Snapshot of a class tree.
// 11 Mar 1996 Derek Lieber
//
package jd;
import  sun.tools.debug.*;
import  util.Tracer;
import  java.util.Vector;
import  java.util.Enumeration;

class ClassTreeSnapshot extends Snapshot
   {
   private ClassTree classTree; // tree to be displayed, with multiple levels of detail
   
   // This snapshot's currently selected class (null --> no selection).
   //
   synchronized
   String
   currentSelection()
      {
   // System.out.println("classtree: lino=" + selectedLino + " name=" + classTree.linoToName(selectedLino));
      return classTree.linoToName(selectedLino);
      }
   
   // Create snapshot of class tree with specified class (if non-null) as "currentSelection" (if found).
   // Runs in "Debugger" thread.
   //
   ClassTreeSnapshot(ClassTree classTree, RemoteClass selectedClass)
      throws Exception
      {
   // Tracer.trace("genText", "classtree");

      this.classTree    = classTree;
      this.selectedLino = -1;
      
      if (selectedClass != null)
         selectedLino = classTree.nameToLino(selectedClass.getName());

      text = classTree.getText();
      }

   // Create a copy of "oldSnapshot", but with new selection at specified line.
   //
   ClassTreeSnapshot(ClassTreeSnapshot oldSnapshot, int lino)
      {
      classTree    = oldSnapshot.classTree;
      selectedLino = lino;
     
      classTree.expandOrCollapse(lino);

      text = classTree.getText();
      }
   }
