// Snapshot of an object value.
// 11 Mar 1996 Derek Lieber
//
package jd;
import  sun.tools.debug.*;
import  util.Tracer;
import  java.util.Vector;
import  java.util.Enumeration;

class ValueSnapshot  extends Snapshot
   {
   private ValueTree valueTree; // value to be displayed, as a tree with multiple levels of detail
   
   // Create snapshot of an object value (possibly null).
   // Runs in "Debugger" thread.
   //
   ValueSnapshot(RemoteStackVariable var)
      throws Exception
      {
   // Tracer.trace("genText", "value");

      selectedLino = -1;
      
      valueTree = (var == null)
                ? new ValueTree(null, null,          null,           "")
                : new ValueTree(null, var.getName(), var.getValue(), "");
      
      valueTree.expandOrCollapse(0);
      valueTree.renumber(0);

      StringBuffer buf = new StringBuffer();
      valueTree.print(buf);
      this.text        = buf.toString();
      }

   // Create a copy of "oldSnapshot", but with new selection at specified line.
   //
   ValueSnapshot(ValueSnapshot oldSnapshot, int lino)
      throws Exception
      {
      valueTree    = oldSnapshot.valueTree;
      selectedLino = lino;

      valueTree.expandOrCollapse(lino);
      valueTree.renumber(0);

      StringBuffer buf = new StringBuffer();
      valueTree.print(buf);
      text = buf.toString();
      }
   }
