// Deliver "alarmFired" notifications at periodic rate.
// 19 Sep 1997 Derek Lieber.
//
package ui;

public class AlarmGenerator extends Thread
   {
   private int           initialDelay;
   private int           repeatRate;
   private AlarmListener alarmListener;
   
   //-----------//
   // interface //
   //-----------//
   
   public
   AlarmGenerator(boolean fast)
      {
      if (fast)
         {
         initialDelay = 500;
         repeatRate   = 50;
         }
      else
         {
         initialDelay = 500;
         repeatRate   = 500;
         }
      start();
      }

   synchronized
   public void
   on(AlarmListener alarmListener)
      {
      this.alarmListener = alarmListener;
      interrupt();
      }

   synchronized
   public void
   off()
      {
      alarmListener = null;
      interrupt();
      }
   
   //------------------------//
   // implementation details //
   //------------------------//

   public void
   run() //- overrides Thread
      {
      for (;;)
         {
         synchronized(this)
            {
            while (alarmListener == null)
               {
               try { wait(); } catch (InterruptedException e) { break; }
               }
            }
            
         try { sleep(initialDelay); } catch (InterruptedException e) { continue; }
         
         while (alarmListener != null)
            {
            alarmListener.alarmFired(this);
            try { sleep(repeatRate); } catch (InterruptedException e) { break; }
            }
         }
      }
   }
